{by Alexey Monastyrenko}
{slightly changed by Valery Votintsev ( vv ) }

{$R-,Q-,S-,Q-}
uses Crt,SetPal;

type TScr = array[0..199,0..319] of Byte;
var Scr: TScr absolute $A000:$0000;
type TScr2 = array[0..63999] of byte;

procedure VIDMode(Mode : Byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

procedure ChangePic(var Pic1:TScr; var Pal1:TPaletteLinear;
                    var Pic2:TScr; var Pal2:TPaletteLinear);
var I,J,K,N:Word;
    R1,R2,RR:Word;
    YMax:array[0..319] of Integer;
    YY:array[0..319] of Integer;
const DropLength=5;
begin
  for I:=0 to 319 do begin
    YY[I]:=Random(200);
    YMax[I]:=199;
  end;
  for I:=0 to (200 div DropLength -1) do begin
    for K:=0 to 110 do begin
      for J:=0 to 319 do begin
       if YMax[J]<>0 then begin
        if YY[J]+1<YMax[J] then begin
          if YY[J]>=0 then
            for N:=0 to DropLength-1 do begin
              Scr[YY[J]+N,J] := Pic1[YY[J]+N,J];
            end;
          Inc(YY[J]);
        end else begin
          YY[J]:=0;
          Dec(YMax[J],DropLength);
        end;
        for N:=0 to DropLength-1 do begin
          Scr[YY[J]+N,J]:=Pic2[YMax[J]-DropLength+1+N,J];
        end;
       end;
      end;
      Delay(3);
    end;
    for J:=0 to 256*3-1 do begin
      PaletteLinear[J]:=(I*DropLength*Pal2[J]+(199-I*DropLength)*Pal1[J]+100) div 199;
    end;
    SetPalette;
  end;
end;

var X,Y,X1,Y1:Integer;
    I,J:Longint;
    F:file;
    Scr3,Scr4: ^TScr;
    Pal3,Pal4:TPalette;
    Pal3L:TPaletteLinear absolute Pal3;
    PAL4L:TPaletteLinear absolute PAL4;
begin
  vidMode($13);                       { 320x200x256 graphics mode }
  GetMem(Scr3,320*200);

  GetMem(Scr4,320*200);
 repeat

  Assign(F,'monster.scr'); ReSet(F,1);
  BlockRead(F,Scr4^,320*200);
  Close(F);
  Assign(F,'monster.PAL'); ReSet(F,1);
  BlockRead(F,PAL4,SizeOf(TPaletteLinear));
  Close(F);

  Assign(F,'monhorse.scr'); ReSet(F,1);
  BlockRead(F,Scr3^,320*200);
  Close(F);
  Assign(F,'monhorse.PAL'); ReSet(F,1);
  BlockRead(F,Pal3,SizeOf(TPaletteLinear));
  Close(F);

  ChangePic(Scr3^,Pal3L,Scr4^,Pal4L); Delay(1000);
  ChangePic(Scr4^,Pal4L,Scr3^,Pal3L); Delay(1000);

 until KeyPressed;
  FreeMem(Scr4,320*200);
  FreeMem(Scr3,320*200);

{vv}  vidMode(3);        { Text mode }

end.