{by Alexey Monastyrenko}
{slightly changed by Valery Votintsev ( vv ) }

{$R-,Q-,S-,Q-}
uses Crt,SetPAL;

type TScr = array[0..199,0..319] of Byte;
var Scr: TScr absolute $A000:$0000;
type TScr2 = array[0..63999] of byte;
var Scr3: ^TScr;
var ISin:array[0..255] of Byte;

const color:byte=255;

Procedure vidMode(mode : byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

procedure ChangePIC(var PIC2:TScr; var PAL2:TPaletteLinear);
var i:word;
    J:Integer;
    X,Y,XX,YY:Word;
    PAL1:TPaletteLinear;
begin
  PAL1:=PaletteLinear;
  for I:=0 to 65535 do begin
    XX:= I xor (I shl 3) xor (I shl 7);
    XX:=XX*17;
    XX:= XX xor (XX shl 3) xor (XX shl 7);
    XX:=XX*37;
    X:=XX mod 320; Y:=XX div 320;
    Scr[Y,X]:=PIC2[Y,X];
    if Lo(I)=128 then begin
      Delay(10);
      for J:=0 to 256*3-1 do begin
        PaletteLinear[J]:=(Hi(I)*PAL2[J]+(255-Hi(I))*PAL1[J]) div 256;
      end;
      SetPalette;
    end;
  end;
(*  for YY:=0 to 199 do begin
    for XX:=0 to 319 do begin
      X:=(XX*7) mod 320; Y:=(YY*27+X*53) mod 200;
      Scr[Y,X]:=PIC2[Y,X];
      if XX=0 then begin
        for J:=0 to 256*3-1 do begin
          PaletteLinear[J]:=(YY*PAL2[J]+(199-YY)*PAL1[J]) div 199;
        end;
        SetPalette;
      end;
    end;
  end;*)
end;

procedure LoadNewPIC(Name:string);
var TmpScr:^TScr;
    F:file;
    PAL2:TPaletteLinear;
begin
  GetMem(TmpScr,64000);
  Assign(F,Name+'.scr'); ReSet(F,1);
  BlockRead(F,TmpScr^,320*200);
  Close(F);
  Assign(F,Name+'.PAL'); ReSet(F,1);
  BlockRead(F,PAL2,SizeOf(TPaletteLinear));
  Close(F);
  ChangePIC(TmpScr^,PAL2);
  FreeMem(TmpScr,65535);
end;

var X,Y,X1,Y1:Integer;
    I,J:Longint;
    F:file;
    PAL2,PAL3:TPalette;
    PAL2L:TPaletteLinear absolute PAL2;
    PAL3L:TPaletteLinear absolute PAL3;
begin
  vidMode($13);                       { 320x200x256 graphics mode }
  SetPalette;
  GetMem(Scr3,65535);

  Randomize;
  for I:=0 to 255 do begin
    ISin[I]:=128+Round(127*Sin(I*2*PI/256));{}
  end;

  FillChar(PAL2,SizeOf(PAL2),#0);
  Palette:=PAL2; SetPalette;

  Assign(F,'nameless.pal'); ReSet(F,1);
  BlockRead(F,PAL3,SizeOf(Palette));
  Close(F);

  for Y:=0 to 199 do begin
    for X:=0 to 319 do begin
      I:=0;
      for J:=1 to 2 do begin
        Inc(I,ISin[Lo((X)*J)]+ISin[Lo((Y)*J)]);{}
      end;
      Scr3^[Y,X]:=I;{}
    end;
  end;
  ChangePIC(Scr3^,PAL3L); Delay(1000);
 repeat
  LoadNewPIC('monhorse'); Delay(1000);
  LoadNewPIC('monster'); Delay(1000);
 until KeyPressed;

{vv>  vidMode(3);       { Text mode }
end.